#include	<stdio.h>
#include	<time.h>
#include	<string.h>

int getlzhhead( FILE *fp )
{
	char	buf[1024], key[]= "-lh";
	int	size, match= 0, place= 0;
	while( size= fread( buf, sizeof( char ), 1024, fp ) ){
		int	i;
		char	*ptr= buf;
		for( i= 0; i < size; i++ ){
			if( *ptr == key[match] ){
				if( ++match == 3 ){
					fseek( fp, place + (ptr - buf) - 4, 0 );
					return 1;
				}
				ptr++;
			}else {
				if( match ){
					match= 0;
				}else {
					ptr++;
				}
			}
		}
		place+= size;
	}
	return 0;
}

static int nread(FILE *fp, int n, unsigned long int *vp)
{
	int c, s;

	*vp = s = 0;
	while (n-- > 0) {
    	if ((c = getc(fp)) == EOF)
    		return -1;
	    *vp |= c << s, s += 8;
	}
	return 0;
}

int listlzh(unsigned char *dir, char *inf, FILE *fp)
{
	unsigned char mid[6], nam[1024];
	unsigned long int siz, org, tim, lev, nln, dln, dummy;
	int tye, tmo, tda, tho, tmi, tse;

	siz= org = tim = lev = nln = dln = 0;

	if (fseek(fp, 2, 1) < 0)
		return 0;
	if (fread(mid, 1, 5, fp) < 5)
		return 0;
	if (mid[0] != '-' || mid[4] != '-')
		return 0;
	if (nread(fp, 4, &siz) < 0 || nread(fp, 4, &org) < 0)
		return -1;
	if (nread(fp, 4, &tim) < 0 || nread(fp, 1, &dummy) < 0)
		return -1;
	if (nread(fp, 1, &lev) < 0 || lev > 2)
		return -1;
	if (lev < 2) {
    	if (nread(fp, 1, &nln) < 0)
    		return -1;
	    if (fread(nam, 1, nln, fp) < nln)
	    	return -1;
    	tse = tim & 31;
    	tim >>= 5;
    	tmi = tim & 63;
    	tim >>= 6;
	    tho = tim & 31;
	    tim >>= 5;
	    tda = tim & 31;
	    tim >>= 5;
    	tmo = tim & 15;
    	tim >>= 4;
    	tye = tim & 127;
	    tse *= 2;
	    tye = ( tye + 80 ) % 100;
	} else {
    	struct tm *lt;

	    lt = localtime((time_t *)&tim);
	    tse = lt->tm_sec;
	    tmi = lt->tm_min;
	    tho = lt->tm_hour;
    	tda = lt->tm_mday;
    	tmo = lt->tm_mon;
    	tye = lt->tm_year % 100;
    }
	if (nread(fp, 2, &dummy) < 0)
		return -1;
	if (lev > 0) {
		unsigned long int	typ, hsz;
	
		hsz= typ= 0;	
		if (nread(fp, 1, &dummy) < 0)
			return -1;
		for ( ; ; ) {
			if (nread(fp, 2, &hsz) < 0)
				return -1;
			if (hsz == 0)
				break;
			if (lev == 1)
				siz-= hsz;
			if (hsz < 3 || nread(fp, 1, &typ) < 0)
				return -1;
			switch (typ) {
			case 1:
				nln= hsz - 3;
				if (fread( nam, 1, nln, fp ) < nln)
					return -1;
				break;
			case 2:
				dln = hsz - 3;
				if (fread(dir, 1, dln, fp) < dln)
					return -1;
				break;
			case 64:
				if (nread(fp, 2, &dummy) < 0)
					return -1;
				break;
			default:
				if (fseek(fp, hsz - 3, 1) < 0)
					return -1;
				break;
			}
		}
	}
	nam[nln]= dir[dln]= 0;
	while (dln-- > 0) {
		if (dir[dln] == 0xff)
			dir[dln] = '/';
	}
	strcat( dir, nam );
	if( strlen( dir ) > 82 )	dir[82]= 0;
	sprintf( inf, "%8d %2d/%02d/%02d %02d:%02d:%02d",
				org, tye, tmo, tda, tho, tmi, tse );
	if (fseek(fp, siz, 1) < 0)
		return -1;

	return 1;
}
